#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   getOFversionWriteConfig.py
#
#       OpenFOAMのバージョンをconfigTreeFoamに書き込む
#       使い方：OpenFOAMの環境設定後、起動する
#
#   12/09/11    新規作成
#

import os
import sys

def readWriteConfigFile(ver):
    fileName = os.environ["TreeFoamPath"] + "/configTreeFoam"
    f = open(fileName)
    cont = f.readlines()
    f.close()
    if ver == "":
        ver = "XXXX"
    n = 0
    flag = 0
    for line in cont:
        if line[:9] == "OFversion":
            cont[n] = line[:9] + " " + ver + "\n"
            flag = 1
            break
        n += 1
    if flag == 0:
        cont.append("# OpenFOAMのバージョン\n")
        cont.append("OFversion " + ver + "\n")
    f = open(fileName, "w")
    for line in cont:
        f.write(line)
    f.close()


#ver = sys.argv[1]
ver = os.environ["WM_PROJECT_VERSION"]
readWriteConfigFile(ver)


