#!/usr/bin/env python
# -*- coding: utf-8 -*-
#
#   createBafflesDialog220.py
#
#       内部patch（baffle）作成
#       OpenFOAM-2.2.0用
#
#   13/06/29    新規作成
#      07/10    初期化のバグ修正
#
# generated by wxGlade 0.6.5 on Sat Jun 29 15:53:47 2013


import wx
import os
import glob
import pyTreeFoam
import getFoamContents
import setFoamContents
import gaugeDDialog

# begin wxGlade: extracode
# end wxGlade


caseDir = ""
timeFolder = ""
startFrom = ""
selRegion = ""
polyMeshDir = ""
regionNames = []
times = []



def Show():
    initialize()
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, u"内部patch（baffle）の作成")
        self.label_2 = wx.StaticText(self, -1, u"createBafflesDictを編集し、内部patchを作成する。\nsubCaseフォルダを作成し、subCase内のメッシュに内部patchを作成する。\n解析case名が「subCase」の場合は、そのまま内部patchを作成する。")
        self.label_3 = wx.StaticText(self, -1, "time")
        self.combo_box_1 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.label_4 = wx.StaticText(self, -1, "region")
        self.combo_box_2 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.sizer_2_staticbox = wx.StaticBox(self, -1, u"meshの選択")
        self.button_2 = wx.Button(self, -1, u"faceZone作成...")
        self.label_5 = wx.StaticText(self, -1, u"topoSetEditor起動")
        self.label_7 = wx.StaticText(self, -1, u"現在のfaceZone")
        self.list_box_1 = wx.ListBox(self, -1, choices=[])
        self.sizer_8_staticbox = wx.StaticBox(self, -1, "faceZone")
        self.button_3 = wx.Button(self, -1, u"空patch作成...")
        self.label_6 = wx.StaticText(self, -1, u"gridEditor起動")
        self.label_8 = wx.StaticText(self, -1, u"現在の空patch")
        self.list_box_2 = wx.ListBox(self, -1, choices=[])
        self.sizer_9_staticbox = wx.StaticBox(self, -1, u"空patch")
        self.sizer_7_staticbox = wx.StaticBox(self, -1, "source")
        self.label_10 = wx.StaticText(self, -1, u"createBafflesDict作成")
        self.button_4 = wx.Button(self, -1, u"Dict編集...")
        self.label_9 = wx.StaticText(self, -1, u"---→")
        self.label_11 = wx.StaticText(self, -1, u"内部patch(baffle)作成")
        self.button_5 = wx.Button(self, -1, u"Dict実行...")
        self.sizer_12_staticbox = wx.StaticBox(self, -1, u"内部patch（baffle）作成")
        self.button_6 = wx.Button(self, -1, u"閉じる")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeTime, self.combo_box_1)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeTime, self.combo_box_1)
        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeRegion, self.combo_box_2)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeRegion, self.combo_box_2)
        self.Bind(wx.EVT_BUTTON, self.onRunTopoSetEditor, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onRunGridEditor, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onEditDict, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onRunDict, self.button_5)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_6)
        # end wxGlade

    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("frame_1")
        self.button_2.SetMinSize((115, 30))
        self.list_box_1.SetMinSize((200, 100))
        self.button_3.SetMinSize((115, 30))
        self.list_box_2.SetMinSize((200, 100))
        # end wxGlade

        self.SetTitle(u"内部patchの作成")
        self.setTimes()
        self.setRegions()
        self.setFaceZones()
        self.setNullPatches()


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_16 = wx.BoxSizer(wx.VERTICAL)
        sizer_17 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_12_staticbox.Lower()
        sizer_12 = wx.StaticBoxSizer(self.sizer_12_staticbox, wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        self.sizer_7_staticbox.Lower()
        sizer_7 = wx.StaticBoxSizer(self.sizer_7_staticbox, wx.HORIZONTAL)
        self.sizer_9_staticbox.Lower()
        sizer_9 = wx.StaticBoxSizer(self.sizer_9_staticbox, wx.VERTICAL)
        sizer_11 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_8_staticbox.Lower()
        sizer_8 = wx.StaticBoxSizer(self.sizer_8_staticbox, wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        self.sizer_2_staticbox.Lower()
        sizer_2 = wx.StaticBoxSizer(self.sizer_2_staticbox, wx.HORIZONTAL)
        sizer_4 = wx.BoxSizer(wx.VERTICAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_3 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_1.Add(self.label_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 10)
        sizer_5.Add(self.label_3, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_5.Add(self.combo_box_1, 1, wx.RIGHT | wx.TOP | wx.BOTTOM | wx.EXPAND, 5)
        sizer_3.Add(sizer_5, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_6.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 5)
        sizer_6.Add(self.combo_box_2, 1, wx.RIGHT | wx.TOP | wx.BOTTOM | wx.EXPAND, 5)
        sizer_4.Add(sizer_6, 1, wx.EXPAND, 0)
        sizer_2.Add(sizer_4, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_10.Add(self.button_2, 0, 0, 0)
        sizer_10.Add(self.label_5, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_8.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_8.Add(self.label_7, 0, wx.LEFT | wx.TOP, 5)
        sizer_8.Add(self.list_box_1, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_7.Add(sizer_8, 1, wx.ALL | wx.EXPAND, 5)
        sizer_11.Add(self.button_3, 0, 0, 0)
        sizer_11.Add(self.label_6, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_9.Add(sizer_11, 0, wx.EXPAND, 0)
        sizer_9.Add(self.label_8, 0, wx.LEFT | wx.TOP, 5)
        sizer_9.Add(self.list_box_2, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 5)
        sizer_7.Add(sizer_9, 1, wx.ALL | wx.EXPAND, 5)
        sizer_1.Add(sizer_7, 1, wx.LEFT | wx.RIGHT | wx.BOTTOM | wx.EXPAND, 10)
        sizer_13.Add(self.label_10, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_13.Add(self.button_4, 0, wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_12.Add(sizer_13, 1, wx.EXPAND, 0)
        sizer_14.Add(self.label_9, 0, wx.LEFT | wx.RIGHT, 20)
        sizer_12.Add(sizer_14, 0, wx.EXPAND, 0)
        sizer_15.Add(self.label_11, 0, wx.ALIGN_CENTER_HORIZONTAL, 0)
        sizer_15.Add(self.button_5, 0, wx.BOTTOM | wx.ALIGN_CENTER_HORIZONTAL, 5)
        sizer_12.Add(sizer_15, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_12, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 10)
        sizer_17.Add(self.button_6, 0, wx.ALL, 20)
        sizer_16.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_16, 0, wx.ALIGN_RIGHT, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    def onChangeTime(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeTime(event)

    def onChangeRegion(self, event):  # wxGlade: MyFrame.<event_handler>
        self.changeRegion(event)

    def onRunTopoSetEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runTopoSetEditor(event)

    def onRunGridEditor(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runGridEditor(event)

    def onEditDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editDict(event)

    def onRunDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runDict(event)

    def onClose(self, event):  # wxGlade: MyFrame.<event_handler>
        self.Destroy()

# end of class MyFrame

    #  setTimes
    #    timeをセット
    def setTimes(self):
        global times, startFrom
        self.combo_box_1.Clear()
        self.combo_box_1.AppendItems(times)
        if startFrom == "firstTime":
            self.combo_box_1.SetSelection(0)
        elif startFrom == "startTime":
            self.combo_box_1.SetSelection(1)
        else:
            self.combo_box_1.SetSelection(2)

    #  getTimeFolder
    #    選択しているtimeFolderを取得
    def getTimeFolder(self):
        selTime = self.combo_box_1.GetStringSelection()
        startFrom = selTime.split(":")[0].split()[0]
        timeFolder = selTime.split(":")[1]
        return [startFrom, timeFolder]

    #  setRegions
    #    regionをセット
    def setRegions(self):
        global regionNames
        self.combo_box_2.Clear()
        self.combo_box_2.AppendItems(regionNames)
        self.combo_box_2.SetSelection(0)

    #  getSelRegion
    #    選択しているregionを取得
    def getSelRegion(self):
        n = self.combo_box_2.GetSelection()
        if n == 0:
            region = "."
        else:
            region = self.combo_box_2.GetStringSelection()
        return region

    #  setFaceZones
    #    faceZoneをセット
    def setFaceZones(self):
        global polyMeshDir
        faceZones = getFoamContents.faceZoneNamesDir(polyMeshDir)
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(faceZones)

    #  setNullPatches
    #    空patchをセット
    def setNullPatches(self):
        global polyMeshDir
        patchConts = getFoamContents.getPatchCont(polyMeshDir)
        nullPatches = []
        for patchCont in patchConts:
            if patchCont[1] == 0:
                nullPatches.append(patchCont[0])
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(nullPatches)

    #  changeTime
    #    timeを変更
    def changeTime(self, event):
        global timeFolder, polyMeshDir, startFrom, selRegion
        [startFrom, timeFolder] = self.getTimeFolder()
        selRegion = self.getSelRegion()
        polyMeshDir = getPolyMeshDir(caseDir, timeFolder, selRegion)
        self.setFaceZones()
        self.setNullPatches()
        systemDir = caseDir + "/system"
        setFoamContents.controlDict(systemDir, [["startFrom", startFrom]]) 

    #  changeRegion
    #    regionを変更
    def changeRegion(self, event):
        self.changeTime(event)

    #  runTopoSetEditor
    #    topoSetEditorの起動
    def runTopoSetEditor(self, event):
        global timeFolder, selRegion
        stlDir = caseDir
        comm = "cd " + caseDir + ";" 
        comm += "topoSetEditor.py " + caseDir + " " + stlDir
        comm += " " + timeFolder + " " + selRegion
        pyTreeFoam.runOFUtility(comm)
        self.changeTime(event)

    #  runGridEditor
    #    gridEditorの起動
    def runGridEditor(self, event):
        global caseDir, timeFolder, selRegion
        region = selRegion
        caseFolder = caseDir.split("/")[-1]
        title = ": " + caseFolder + "/" + timeFolder + "/" + region
        fieldDir = caseDir + "/" + timeFolder + "/" + region
        if len(glob.glob(fieldDir + "/polyMesh/boundary")) != 0:
            boundaryDir = fieldDir + "/polyMesh"
        else:
            boundaryDir = caseDir + "/constant/" + region + "/polyMesh"
        #grid表示
        nTreeFoam = "-1"
        comm = "runGridEditor.py "
        comm+= nTreeFoam + " '" + title + "' " + boundaryDir + " " + fieldDir
        os.system(comm)
        self.changeTime(event)

    #  editDict
    #    createBafflesDictの編集
    def editDict(self, event):
        global caseDir, selRegion
        selRegion = self.getSelRegion()
        fileName = caseDir + "/system/" + selRegion + "/createBafflesDict"
        if len(glob.glob(fileName)) == 0:
            cont = makeCreateBafflesDict()
            f=open(fileName, "w"); f.write(cont); f.close()
            title = u"createBafflesDict編集"
            mess = u"標準の「createBafflesDict」を作成しました。"
            self.okDialog(title, mess)
        openFileName = fileName
        pyTreeFoam.runEditor(openFileName)

    #  runDict
    #    createBafflesの実行
    def runDict(self, event):
        global caseDir, timeFolder, selRegion
        #「subCase」有無確認
        if len(glob.glob(caseDir + "/subCase")) != 0:
            title = u"エラー"
            mess = u"既に「subCase」が存在します。\n削除後、実行してください。"
            self.errDialog(title, mess)
            return

        #createBaffles実行
        selRegion = self.getSelRegion()
        if selRegion == ".":
            comm = "createBaffles"
        else:
            comm = "createBaffles -region " + selRegion
        print comm
        [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        if stat != "OK":
            title = u"エラー"
            mess = u"実行エラーが発生しました。\nlogを確認してください。"
            self.errDialog(title, mess)
            return

        #subCase作成
        comm = "mkdir " + caseDir + "/subCase"
        os.system(comm)
        #caseをコピー
        [startFrom, timeFolder] = self.getTimeFolder()
        copyFolders = [timeFolder, "constant", "system"]
        #meshをコピー
        [deltaT] = getFoamContents.controlDict(
                        caseDir + "/system", ["deltaT"])
        writeTime = float(timeFolder) + float(deltaT)
        timeFolders = pyTreeFoam.getTimeFolders(caseDir)
        for folder in timeFolders:
            time = float(folder)
            if writeTime == time:
                meshFolder = folder + "/" + selRegion + "/polyMesh"
                meshTime = folder
                break
        #foldersをpaste        
        error = copyCaseFolders(caseDir, copyFolders, meshFolder, caseDir+"/subCase")
        if error != "OK":
            title = u"エラー"
            mess = u"コピー時にエラーが発生しました。"
            self.errDialog(title, mess)
            return

        #親folderのmeshfolderを削除
        delFolder = caseDir + "/" + meshFolder
        comm = "rm -rf " + delFolder
        os.system(comm)
        if timeFolders[-1] == meshTime:
            delFolder = caseDir + "/" + meshTime
            comm = "rm -rf " + delFolder
            os.system(comm)
            
        #終了メッセージ
        title = u"内部patch作成"
        mess = u"内部patchを作成しました。\n解析caseを「subCase」に設定してください。"
        self.okDialog(title, mess)


    #----------------------------------------------------------
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()


#  copyCaseFolders
#    caseをコピーする
def copyCaseFolders(copyCase, copyFolders, meshFolder, copyTo):
    copyDirs = []
    newDirs = []
    for folder in copyFolders:
        copyDirs.append(copyCase + "/" + folder)
        newDirs.append(copyTo + "/" + folder)
    copyDirs.append(copyCase + "/" + meshFolder)
    timeFolder = copyFolders[0]
    polyMesh = "/".join(meshFolder.split("/")[1:])
    newDirs.append(copyTo + "/" + timeFolder + "/" + polyMesh)
    #paste開始
    gaugeDDialog.job = "copy"
    gaugeDDialog.title = u"folder, fileのコピー"
    gaugeDDialog.copyDirs = copyDirs
    gaugeDDialog.newDirs = newDirs
    dialog = gaugeDDialog.MyDialog(None)
    reult = dialog.ShowModal()
    ans = gaugeDDialog.status
    #コピーをキャンセルした場合
    #  ans="NG"
    #エラーが発生した場合
    #  ans="ERR"
    return ans
    



#
#  makeCreateBafflesDict
#    createBafflesDictを作成
def makeCreateBafflesDict():
    version = pyTreeFoam.readConfigTreeFoam()[0]
    header = setFoamContents.makeFoamHeaderVersion(version)
    foamFile = setFoamContents.makeFoamFile("2.0", "ascii", "dictionary", "", "createBafflesDict") 
    footer = setFoamContents.makeFooter()
    cont = """// Whether to convert internal faces only (so leave boundary faces intact).
// This is only relevant if your face selection type can pick up boundary
// faces.
internalFacesOnly true;

// Baffles to create.
baffles
{
    creatBaffle         //baffle作成
    {
        //- Use predefined faceZone to select faces and orientation.
        type        faceZone;
        zoneName    cycLeft;

        patches
        {
            master
            {
                //- Master side patch

                name            cycLeftPatch;
                type            patch;
            }
            slave
            {
                //- Slave side patch

                name            cycLeftPatch;
                type            patch;
            }
        }
    }

    createIntPatch          //表裏のpatch作成
    {
        //- Use predefined faceZone to select faces and orientation.
        type        faceZone;
        zoneName    cycRight;

        patches
        {
            master
            {
                //- Master side patch

                name            cycRight_half0;
                type            patch;
                neighbourPatch  cycRight_half1;
            }
            slave
            {
                //- Slave side patch

                name            cycRight_half1;
                type            cyclic;
                neighbourPatch  cycRight_half0;
            }
        }
    }
}
"""
    allCont = header + foamFile + cont + footer
    return allCont


def initialize():
    global caseDir, timeFolder, regionNames, startFrom, times, regionNames
    global polyMeshDir, selRegion
    caseDir = os.getcwd()
    #timesを取得
    contDir = caseDir + "/system"
    [startFrom, startTime] = getFoamContents.controlDict(contDir, ["startFrom", "startTime"])
    timeFolders = pyTreeFoam.getTimeFolders(caseDir)
    firstTime = timeFolders[0]
    latestTime = timeFolders[-1]
    times = []
    times.append("firstTime :" + firstTime)
    times.append("startTime :" + startTime)
    times.append("latestTime:" + latestTime)
    if startFrom == "firstTime":
        timeFolder = firstTime
    elif startFrom == "startTime":
        timeFolder = startTime
    else:
        timeFolder = latestTime
    #regionsを取得
    regionNames = []
    [isRegion, loc, names] = pyTreeFoam.checkMultiRegion(caseDir)
    if isRegion == False:
        names = []
    regionNames.append("(region0)")
    for name in names:
        regionNames.append(name)
    selRegion = "."
    #polyMeshDirを取得
    polyMeshDir = getPolyMeshDir(caseDir, timeFolder, selRegion)

#
#  getPolyMeshDir
#    polyMeshDirを取得
def getPolyMeshDir(caseDir, timeFolder, region):
    polyMeshDir = caseDir + "/" + timeFolder + "/" + region + "/polyMesh"
    if len(glob.glob(polyMeshDir+"/boundary")) == 0:
        polyMeshDir = caseDir + "/constant/" + region + "/polyMesh"
    return polyMeshDir




if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
