#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Sat Feb 18 16:47:12 2012
#
#   gaugeDDialog.py
#
#     load, save, copy時にゲージを出力させる。
#
#       12/02/19    新規作成
#          02/26    load部分をclass外に出す
#          04/01    save部分を追加
#          04/08    copy部分を追加（folderのコピー:TreeFoam）
#          04/23    load, saveでｴﾗｰ処理追加
#          05/10    copy部分のメッセージ追加
#          06/22    copy：folder複数選択を可能に変更。絶対pathのlinkのコピーを可能に設定
#          10/10    copy：空フォルダのコピーを追加。相対pathのlinkを可能に設定
#       13/06/09    shutil.copyfileをshutil.copyに変更（ﾊﾟｰﾐｯｼｮﾝがｺﾋﾟｰされない為）
#                   load時、「patch.*」が読めるように修正
#          06/10    save時、「patch.*」が保存できる様に修正
#                   load, save時「"(xxx.*|yyyy)"」も追加
#                   save時、boundaryField内のpatch以外の行（#include等）を残す様に修正
#

import wx
import getFoamContents
import pyTreeFoam
import thread
import string
import os
import glob
import shutil
import codecs
import re


# begin wxGlade: extracode
# end wxGlade

title = ""
status = ""
error = ["OK", ""]
job = ""
dataDir = ""
Value = 0.0
Message = ""
colNames = []
rowNames = []
data = []
intData = []
deltaT = 100            #event timerの間隔(ms)をセット
copyDir = ""            #copy元Dir
newDir = ""             #copy先Dir
copyDirs = []
newDirs = []
oldDir = ""
checkDir = ""
maxRowsInCell = 15              #gridEditorの最大cell内行数（load時）
nMaxLinesBinToAscii = 500       #binary→ascii変換する行数


class MyDialog(wx.Dialog):
    def __init__(self, *args, **kwds):
        global job, status, deltaT
        # begin wxGlade: MyDialog.__init__
        kwds["style"] = wx.DEFAULT_DIALOG_STYLE
        wx.Dialog.__init__(self, *args, **kwds)
        self.label_1 = wx.StaticText(self, -1, "label_1\n")
        self.gauge_1 = wx.Gauge(self, -1, 100)
        self.button_1 = wx.Button(self, -1, u"キャンセル")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onCancel, self.button_1)
        # end wxGlade

        self.Bind(wx.EVT_TIMER, self.setGaugeValue)
        self.timer = wx.Timer(self)
        self.timer.Start(deltaT)

        status = "OK"
        thread.start_new_thread(loadSaveData, ())
       


    def __set_properties(self):
        global title
        # begin wxGlade: MyDialog.__set_properties
        self.SetTitle("dialog_1")
        self.gauge_1.SetMinSize((300, 14))
        # end wxGlade

        self.SetTitle(title)


    def __do_layout(self):
        # begin wxGlade: MyDialog.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_1.Add(self.label_1, 0, wx.ALL, 10)
        sizer_1.Add(self.gauge_1, 0, wx.LEFT|wx.RIGHT|wx.BOTTOM, 10)
        sizer_1.Add(self.button_1, 0, wx.RIGHT|wx.BOTTOM|wx.ALIGN_RIGHT, 10)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade


    def onCancel(self, event): # wxGlade: MyDialog.<event_handler>
        global status, Value
        status = "NG"
        Value = 101.0
        self.Destroy()


    def setGaugeValue(self, event):
        global Value, Message, deltaT
        self.timer.Stop()
        if Value >= 100:
            self.Destroy()
        else:
            self.label_1.SetLabel(Message)
            self.gauge_1.SetValue(Value)
            self.timer.Start(deltaT)

# end of class MyDialog

    #-----------------------
    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()



#
#  loadSaveData
#    jobの振り分け
def loadSaveData():
    global job, dataDir, colNames, data, intData, Value, error
    error = ["OK", ""]
    if job == "load":
        data = getLoadData(dataDir, colNames)
    elif job == "save":
        error = saveData(dataDir, colNames, rowNames, data, intData)
    elif job == "copy":
        global copyDirs, newDirs
        copyFolder(copyDirs, newDirs)
    elif job == "checkLink":
        global checkDir, oldDir, newDir
        checkLink(checkDir, oldDir, newDir)
    #処理の終了（timerHandlerへ知らせる）
    Value = 101.0
    return

#----------------
#  load ------------------------------------------------
#----------------

#  getLoadData
#    dataの読み込み
def getLoadData(dataDir, fields):
    global rowNames, maxRowsInCell
    if len(fields) == 0:
        patchData = []
        return patchData
    #patchDataを各Fieldから取得
    [files, patchesF, patchData] = getFieldsPatchesName(dataDir, fields, rowNames)
    #patchDataを修正
    data=[]; j=0
    for fieldPatch in patchData:
        fieldData=[]
        for patch in rowNames:
            i=0; flag=0
            while i<len(fieldPatch) and flag==0:
                if patch == patchesF[i]:
                    fieldData.append(fieldPatch[i])
                    flag = 1
                i += 1
            if flag == 0:
                fieldData.append("")
        data.append(fieldData)
        j += 1
    patchData = data
    #patchDataの文字数をチェック、修正
    data = []
    for field in patchData:
        i=0
        while i<len(field):
            patchCont = field[i].split("\n")
            if len(patchCont) > maxRowsInCell:
                field[i] = "\n".join(patchCont[:maxRowsInCell]) + "..."
            i+=1
        data.append(field)
    dataA = reformPatchData(data)
    return dataA

#  reformPatchData
#    patch内容を修正
#    {}内は、sp(4)を加える
def reformPatchData(data):
    ans = []
    sp = " "
    for patchCont in data:
        patchConts = []
        for cont in patchCont:
            flag = 0
            lines = []
            linesCont = cont.split("\n")
            for line in linesCont:
                if len(line) > 0:
                    if line[0] == "}":
                        flag -= 1
                    if line[0] == "{":
                        flag += 1
                    if flag != 0:
                        #flagの値に応じてspを加える
                        if line[0] == "{":
                            line = (sp * (flag-1)*4) + line
                        else:
                            line = (sp * (flag*4)) + line
                    lines.append(line)
            conts = "\n".join(lines)
            patchConts.append(conts)
        ans.append(patchConts)
    return ans

#
#  getFieldsPatchesName
#    各fieldのpatchDataを取得
def getFieldsPatchesName(wdir, files, rowNames):
    global Value, Message, nMaxLinesBinToAscii
    Value = 0.0                                 #gauge：値をクリア
    dValue = 100.0 / float(len(files) + 1)      #gauge：増分をセット
    fieldsPatch = []
    patchData = []
    for name in files:
        pValue = str(int(Value))
        Message = pValue + "% " + name + u" ...読み込み中"        #gauge：メッセージ
        patchesCont = []
        fileName = wdir + "/" + name
        fileName = getFoamContents.checkFileName(fileName)
        if len(glob.glob(fileName)) != 0:
            #f=open(fileName); contents=f.read(); f.close()
            contents = getFoamContents.readField(fileName, nMaxLinesBinToAscii)
            p=0
            [boundary, p] = getFoamContents.getKeywordContentsMem(
                                "boundaryField", contents, p)
            [patchCont, p] = getFoamContents.getNextKeywordAndContentsMem(
                                boundary, 0)
            while patchCont[0] != "":
                patchesCont.append(patchCont)
                [patchCont,p]=getFoamContents.getNextKeywordAndContentsMem(
                                    boundary, p)

        fieldsPatch.append(patchesCont)
        Value += dValue                         #gauge：増分を加える

    for fieldPatch in fieldsPatch:
        col=[]
        patches = []
        for patchC in fieldPatch:
            patches.append(patchC[0])
        for patch in patches:
            col.append("")
        for fpatch in fieldPatch:
            flag = 0; i=0
            for patch in patches:
                if fpatch[0] == patch:
                    col[i]=pyTreeFoam.compressSPCR(fpatch[1])
                    flag = 1
                    break
                i+=1
            if flag == 0:
                patches.append(fpatch[0])
                col.append(pyTreeFoam.compressSPCR(fpatch[1]))
        #boundaryのpatchに対するpatchContに変換
        col = getFitBoundaryPatchCont(col, patches, rowNames)
        patchData.append(col)
    return [files, rowNames, patchData]

#  getFitBoundaryPatchCont
#    boundaryのpatchに対するpatchContに変換
#    boundaryFieldに「"patch_to_*"」が存在する場合がある為
def getFitBoundaryPatchCont(col, patches, rowNames):
    ans = []
    for name in rowNames:
        ans.append("")
    p=0
    while p<len(patches):
        patch = patches[p]
        i=0
        while i<len(rowNames):
            if patch == rowNames[i]:
                ans[i] = col[p]
                break
            else:
                if patch[0] == '"':
                    #patternマッチングをチェック
                    pattern = patch[1:-1]
                    if pyTreeFoam.isMatchName(rowNames[i], pattern) == True:
                        ans[i] = col[p]
            i += 1
        p += 1
    return ans


#----------------
#  save ------------------------------------------------
#----------------

#
#  saveData
#    データ保存
def saveData(dataDir, fields, rowNames, patchData, intData):
    global Value, Message, nMaxLinesBinToAscii
    patches = []
    for patch in rowNames:
        patches.append("    " + patch)

    #fieldの保存
    Value = 0.0                             #gauge値をクリア
    dValue = 100.0 / float(len(fields) + 1) #増分をセット
    i=0
    mess = ""
    while i<len(fields) and status=="OK":
        pValue = str(int(Value))
        Message = pValue + "% " + fields[i] + u" ...保存中"        #gauge：メッセージ
        #fieldをオープン
        field = fields[i]
        fileName = dataDir + "/" + field
        fileName = getFoamContents.checkFileName(fileName)
        #ファイルがopenできるかどうかチェック
        if len(glob.glob(fileName)) != 0:
            #f=open(fileName); contents=f.read(); f.close()
            contents = getFoamContents.readField(fileName, nMaxLinesBinToAscii)
            #internalFieldを作成、置き換え
            contents = pyTreeFoam.makeReplaceInternalField(fields, intData[i], contents)
            #patchDataを元に戻す（"..."がある場合）
            patchDataH = pyTreeFoam.remakeBoundaryField(contents, patches, patchData[i])
            #patchDataから「boundaryField」を作成
            newBoundary = pyTreeFoam.makeBoundaryField(patches, patchData[i])
            #patchData以外を追加(#include 等)
            newBoundary = addWithoutPatchCont(newBoundary, contents, rowNames)
            #「boundaryField」を置き換える
            newContents = pyTreeFoam.replaceBoundaryField(newBoundary, contents)
            if newContents != "":
                #f=open(fileName,"w"); f.write(newContents); f.close()
                getFoamContents.writeField(fileName, newContents)
            else:
                print "error:",field,"が置き換えできませんでした。"
                mess += field + ","
        else:
            print "error:",field,"が置き換えできませんでした。"
            mess += field + ","
        i+=1
        Value += dValue                     #増分を加える

    if mess == "":
        error = ["OK", ""]
    else:
        error = ["NG", mess[:-1]+u" が保存できていません。"]
        title = u"エラー"
        mess = error[1]
    return error

#  addWithoutPatchCont
#    boundaryFieldにpatchCont以外（#include等）を追加する
def addWithoutPatchCont(newBoundary, allCont, rowNames):
    p = getFoamContents.skipFoamFileMem(allCont, 0)
    [boundaryCont, p] = getFoamContents.getKeywordContentsMem(
                        "boundaryField", allCont, p)
    #boundaryContからpatchデータ以外を取得
    addCont = ""
    p=0
    cont = " "
    while cont != "" and p<len(boundaryCont):
        [cont, p, kind] = getFoamContents.get1lineMem(boundaryCont, p)
        if kind != "keyword":
            addCont += "    " + cont + "\n"
    #boundaryContに行を追加
    newBoundary = addCont + newBoundary
    return newBoundary
    


#----------------
#  copy ------------------------------------------------
#----------------

#
#  copyFolder
#    flderのコピー
def copyFolder(copyDirs, newDirs):
    global Value, Message, status, error
    Value = 0.0                                 #gauge値をクリア

    #コピーするファイル名を取得
    MessageC = u"コピーの準備中..."
    copyFiles = []
    newFiles = []
    copyFolders = []
    newFolders = []
    linkDir = []
    newLinkDir = []
    newLinktoDir = []          #相対リンク先
    linkFiles = []
    newLinkFiles = []
    newLinktoFiles = []
    i=-1
    for copyDir in copyDirs:
        i += 1
        if os.path.isdir(copyDir) == True:
            #コピーするフォルダ内のファイル名とコピー先のファイル名を取得
            for (root, dirs, files) in os.walk(copyDir):
                #フォルダのリンクのみを検索
                for name in dirs:
                    dirName = root + "/" + name
                    if os.path.islink(dirName) == True:
                        linkDir.append(dirName)
                        newDirName = newDirs[i] + dirName[len(copyDir):]
                        newLinkDir.append(newDirName)
                        linkto = os.readlink(dirName)
                        newLinktoDir.append(getNewLink(dirName, linkto, newDirName))
                    if status != "OK":
                        break
                #空フォルダの検索
                for name in dirs:
                    dirName = root + "/" + name
                    if len(glob.glob(dirName+"/*")) == 0:
                        copyFolders.append(dirName)
                        newDirName = newDirs[i] + dirName[len(copyDir):]
                        newFolders.append(newDirName)
                    if status != "OK":
                        break
                #フォルダ内のファイルのリスト作成
                for name in files:
                    copyFile = root + "/" + name
                    newFile = newDirs[i] + copyFile[len(copyDir):]
                    if os.path.islink(copyFile) == True:
                        linkto = os.readlink(copyFile)
                        #linkFiles.append(copyFile)
                        linkDir.append(copyFile)
                        #newLinkFiles.append(newFile)
                        newLinkDir.append(newFile)
                        #linkto = os.readlink(copyFile)
                        #newLinktoFiles.append(getNewLink(copyFile, linkto, newFile))
                        newLinktoDir.append(getNewLink(copyFile, linkto, newFile))
                    else:
                        copyFiles.append(copyFile)
                        newFiles.append(newFile)
                    Message = MessageC + " " + str(len(copyFiles))
                    if status != "OK":
                        break
            if status != "OK":
                break
        else:
            #ファイルのコピーの場合
            copyFiles.append(copyDir)
            newFiles.append(newDirs[i])
    if status == "OK":
        dValue = 100.0 / float(len(copyFiles) + len(linkDir) + 1)  #gaugeの増分をセット
    else:
        return


    #ファイルのコピー開始
    i = 0
    errorFiles = []
    while i<len(copyFiles) and status=="OK":
        newName = newFiles[i].split("/")[-1]
        newNameDir = newFiles[i][:-(len(newName)+1)]
        pValue = str(int(Value))
        Message = pValue + "% " + newName + u" ...コピー中"        #gauge：メッセージ
        #コピー先にフォルダがあるか？
        if len(glob.glob(newNameDir)) == 0:
            #フォルダ作成
            comm = "mkdir -p " + newNameDir
            os.system(comm.encode("utf-8"))
        #ファイルをコピー
        if os.path.isfile(copyFiles[i]) == True:
            print "copy:", newFiles[i]
            #shutil.copyfile(copyFiles[i], newFiles[i])
            shutil.copy(copyFiles[i], newFiles[i])
        elif os.path.islink(copyFiles[i]) == True:
            linkto = os.readlink(copyFiles[i])
            os.symlink(linkto, newFiles[i])
        else:
            errorFiles.append(newFiles[i])
        Value += dValue
        i += 1
    #空フォルダのコピー
    i=0
    while i<len(copyFolders) and status == "OK":
        newNameDir = newFolders[i]
        comm = "mkdir -p " + newNameDir
        os.system(comm.encode("utf-8"))
        i += 1
    #リンクを作成
    i=0
    while i<len(linkDir) and status == "OK":
        newName = newLinkDir[i].split("/")[-1]
        newNameDir = "/".join(newLinkDir[i].split("/")[:-1])
        pValue = str(int(Value))
        Message = pValue + "% " + newName + u" ...コピー中"        #gauge：メッセージ
        #コピー先にフォルダがあるか？
        if len(glob.glob(newNameDir)) == 0:
            #フォルダ作成
            comm = "mkdir -p " + newNameDir
            os.system(comm.encode("utf-8"))
        #リンク作成
        linkto = os.readlink(linkDir[i])
        if linkto[0] != ".":
            #絶対pathのリンク
            flag = 0
            if os.path.isdir(newLinktoDir[i]) == True:
                try:
                    os.symlink(newLinktoDir[i], newLinkDir[i])
                    flag = 1
                    print u"相対参照で「" + newLinkDir[i] + u"」リンクを作成しました。"
                except:
                    flag = 0
            if flag == 0:
                try:
                    os.symlink(linkto, newLinkDir[i])
                    print u"絶対参照で「" + newLinkDir[i] + u"」リンクを作成しました。"
                except:
                    errorFiles.append(newLinkDir[i])
        else:
            #相対pathのリンク
            print u"相対pathで「" + linkto + u"」リンクを作成しました。"
            os.symlink(linkto, newLinkDir[i])
        Value += dValue
        i += 1

    if len(errorFiles) != 0:
        i=0
        msg = u"以下のファイルがコピーできませんでした。\n"
        for errorFile in errorFiles:
            if i<5:
                msg += errorFile + "\n"
            if i == 5:
                msg += "...\n"
            i += 1
            print "error:", errorFile
        print u"上記fileは、コピーできませんでした。"
        status = "ERR"
        error = [u"ERR", msg]


def getNewLink(copyDir, linkto, newDir):
    copyList = copyDir.split("/")
    linktoList = linkto.split("/")
    newList = newDir.split("/")
    i=0
    while i<len(copyList) and copyList[i]==linktoList[i]:
        i += 1
    newLinkto = ""    
    if copyList[i]!=linktoList[i]:
        endDir = "/".join(linktoList[i:])
        topDir = "/".join(newList[:-(len(copyList) - i)])
        newLinkto = topDir + "/" + endDir
    return newLinkto


#----------------
#  checkLink ------------------------------------------------
#----------------

#
#  checkLink
#    リンクをチェック修正
def checkLink(checkDir, oldDir, newDir):
    global Value, Message, status, data
    Value = 0.0                                 #gauge値をクリア

    number = 0
    contCheckDir = getCheckDir(checkDir, newDir)
    dValue = 90.0 / float(len(contCheckDir))

    for checkLinkDir in contCheckDir:
        data = []
        #folder毎にlinkをチェック
        MessageC = checkLinkDir.split("/")[-1] + u"\n"
        for (root, folders, files) in os.walk(checkLinkDir):
            for folder in folders:
                number += 1
                #Message = MessageC + " " + str(number)
                if os.path.islink(root+"/"+folder) == True:
                    data.append(root+"/"+folder)
            for fileName in files:
                number += 1
                #Message = MessageC + " " + str(number)
                if os.path.islink(root+"/"+fileName) == True:
                    data.append(root+"/"+fileName)

        #linkの修正開始
        for linkDir in data:
            pValue = str(int(Value))
            Message = MessageC + pValue + u"% ...チェック中" 
            linkto = os.readlink(linkDir)
            if len(linkto) >= len(oldDir):
                if (oldDir == linkto[:len(oldDir)] and linkto[len(oldDir)] == "/"):
                    newlinkto = newDir + linkto[len(oldDir):]
                    if len(glob.glob(newlinkto)) != 0:
                        os.remove(linkDir)
                        os.symlink(newlinkto, linkDir)
                        print u"link修正--> ", linkDir
        Value += dValue

def getCheckDir(checkDir, newDir):
    [contDirs, files] = pyTreeFoam.getFoldersFiles(checkDir)
    ans = [newDir]
    for folder in contDirs:
        Dir = checkDir + "/" + folder
        if Dir != newDir:
            ans.append(Dir)
    return ans    


def checkLink_bak(checkDir, oldDir, newDir):
    global Value, Message, status, data
    Value = 0.0                                 #gauge値をクリア

    MessageC = u"準備中..."
    number = 0
    data = []
    for (root, folders, files) in os.walk(checkDir):
        for folder in folders:
            number += 1
            Message = MessageC + " " + str(number)
            if os.path.islink(root+"/"+folder) == True:
                data.append(root+"/"+folder)
        for fileName in files:
            number += 1
            Message = MessageC + " " + str(number)
            if os.path.islink(root+"/"+fileName) == True:
                data.append(root+"/"+fileName)

    #linkの修正開始
    dValue = 100.0 / float(number + 1)
    messageC = u"link修正中..."
    for linkDir in data:
        pValue = str(int(Value))
        message = pValue + "% " + messageC 
        linkto = os.readlink(linkDir)
        if len(linkto) >= len(oldDir):
            if (oldDir == linkto[:len(oldDir)] and linkto[len(oldDir)] == "/"):
                newlinkto = newDir + linkto[len(oldDir):]
                if len(glob.glob(newlinkto)) != 0:
                    os.remove(linkDir)
                    os.symlink(newlinkto, linkDir)
                    print u"link修正--> ", linkDir
        Value += dValue




if __name__ == "__main__":
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    dialog_1 = MyDialog(None, -1, "")
    app.SetTopWindow(dialog_1)
    dialog_1.Show()
    app.MainLoop()
