#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Sat Sep 22 15:15:09 2012
#
#   runHelyxosDialog.py
#      module: helyxosShow
#
#   HelyxOS起動用のdialog
#
#
#   12/09/22    新規作成
#      09/30    topoSetEditorの起動を追加
#      11/17    caseDir, stlDir, eMeshDirをrunHlyxOS側に送る様に修正
#   13/04/20    cellSet抽出を削除（toposetEditorに置き換え）
#      05/02    stlDirの相対参照→絶対参照変換方法修正
#      07/14    featureEdge作成fileの選択を追加。snappyDict編集実行ﾎﾞﾀﾝ追加
#      07/20    meshClear用のcheckBoxを追加、meshデータcheck方法変更
#      09/06    paraFoam起動ボタン追加
#
#---------code生成後の修正項目----------------
#   
#   ・アイコンのDirを書き直す（絶対path→相対path[./icons/***.png]）
#

import wx
import os
import sys
import gio
import glob
import shutil
import codecs
import pyTreeFoam
import getOpenFolderDDialog
from setHelyxosPath import getHelyxVersion
from getOpenFileDDialog import selFilesShow as getFilesDialog

version = ""                 #HelyxOSのバージョン
caseDir = ""
stlDir = ""
clipBoard = os.environ["TreeFoamPath"] + "/clipBoard"
helyxDataFile = "data/helyxOS_data"
clearMesh = "yes"

# begin wxGlade: extracode
# end wxGlade

#
def helyxosShow(wdir):
    global caseDir
    caseDir = wdir
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()



class MyFrame(wx.Frame):
    def __init__(self, *args, **kwds):

        #現在のpathを保存
        savePath = os.getcwd()
        #pathをTreeFoamに設定
        treeFoamPath = os.getenv("HOME") + "/TreeFoam"
        os.chdir(treeFoamPath)

        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_1 = wx.StaticBitmap(self, -1, wx.Bitmap("./icons/helyxos-F.png", wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, -1, u"Helyx-OSによる編集", style=wx.ALIGN_CENTRE)
        self.static_line_1 = wx.StaticLine(self, -1)
        self.button_9 = wx.Button(self, -1, "newCase")
        self.label_11 = wx.StaticText(self, -1, u"HelyxOSが編集できるようにfolder, fileを準備\n(既にfileが存在する場合は、そのまま)  ")
        self.label_10 = wx.StaticText(self, -1, u"stlファイルの場所")
        self.button_6 = wx.Button(self, -1, u"開く")
        self.text_ctrl_2 = wx.TextCtrl(self, -1, "")
        self.button_8 = wx.Button(self, -1, u"参照...")
        self.button_2 = wx.Button(self, -1, u"stlチェック")
        self.label_4 = wx.StaticText(self, -1, u"stlのsolid名有無チェック、修正")
        self.button_1 = wx.Button(self, -1, u"特徴線の抽出")
        self.text_ctrl_1 = wx.TextCtrl(self, -1, "")
        self.label_2 = wx.StaticText(self, -1, u"(角度)")
        self.label_3 = wx.StaticText(self, -1, u"fileを選択し、「surfaceFeatureExtract -includedAngle」 を実行")
        self.button_4 = wx.Button(self, -1, u"HelyxOSの起動")
        self.label_7 = wx.StaticText(self, -1, u"snappyHexMeshによるメッシュ作成、一部solverの実行")
        self.checkbox_1 = wx.CheckBox(self, -1, u"mesh作成、編集する")
        self.button_3 = wx.Button(self, -1, u"paraFoam起動")
        self.label_5 = wx.StaticText(self, -1, u"paraFoamを起動して、mesh確認")
        self.button_10 = wx.Button(self, -1, u"snappyDict編集")
        self.label_12 = wx.StaticText(self, -1, u"→")
        self.button_11 = wx.Button(self, -1, u"snappy実行")
        self.label_8 = wx.StaticText(self, -1, u"HelyxOSが作り出したblockMeshDict、snappyHexMeshDictを編集し、\n実行する事でmeshを再作成する")
        self.button_7 = wx.Button(self, -1, u"mesh抽出")
        self.label_9 = wx.StaticText(self, -1, u"topoSet Editorによるメッシュ抽出")
        self.static_line_2 = wx.StaticLine(self, -1)
        self.button_5 = wx.Button(self, -1, u"閉じる")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_BUTTON, self.onCaseInitialize, self.button_9)
        self.Bind(wx.EVT_BUTTON, self.onOpenStlFolder, self.button_6)
        self.Bind(wx.EVT_BUTTON, self.onSetStlLocation, self.button_8)
        self.Bind(wx.EVT_BUTTON, self.onStlCheck, self.button_2)
        self.Bind(wx.EVT_BUTTON, self.onFeatureEdge, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.onRunHelyxos, self.button_4)
        self.Bind(wx.EVT_BUTTON, self.onRunParaFoam, self.button_3)
        self.Bind(wx.EVT_BUTTON, self.onEditSnappyDict, self.button_10)
        self.Bind(wx.EVT_BUTTON, self.onRunSnappy, self.button_11)
        self.Bind(wx.EVT_BUTTON, self.onTopoSetEditor, self.button_7)
        self.Bind(wx.EVT_BUTTON, self.onClose, self.button_5)
        # end wxGlade

        #pathを戻す
        os.chdir(savePath)



    def __set_properties(self):
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle("frame_1")
        self.button_9.SetMinSize((110, 30))
        self.button_6.SetMinSize((40, 30))
        self.text_ctrl_2.SetMinSize((330, 28))
        self.button_8.SetMinSize((60, 30))
        self.button_2.SetMinSize((110, 25))
        self.button_1.SetMinSize((110, 40))
        self.button_4.SetMinSize((110, 50))
        self.button_3.SetMinSize((110, 40))
        self.button_10.SetMinSize((110, 25))
        self.button_11.SetMinSize((110, 25))
        self.button_7.SetMinSize((110, 25))
        # end wxGlade

        self.text_ctrl_1.SetValue("150")
        self.SetTitle(u"HelyxOSによる編集")
        self.setDataToTextBox()

    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_4 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_16 = wx.BoxSizer(wx.VERTICAL)
        sizer_17 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.VERTICAL)
        sizer_21 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_18 = wx.BoxSizer(wx.VERTICAL)
        sizer_19 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_20 = wx.BoxSizer(wx.VERTICAL)
        sizer_5 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_14 = wx.BoxSizer(wx.VERTICAL)
        sizer_3 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_15 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2.Add((50, 50), 0, 0, 0)
        sizer_2.Add(self.bitmap_1, 0, wx.ALL | wx.ALIGN_CENTER_HORIZONTAL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_2.Add(self.label_1, 0, wx.ALL | wx.ALIGN_CENTER_VERTICAL, 10)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_1.Add(self.static_line_1, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 20)
        sizer_15.Add(self.button_9, 0, wx.LEFT | wx.TOP, 20)
        sizer_15.Add(self.label_11, 0, wx.LEFT | wx.ALIGN_BOTTOM, 20)
        sizer_9.Add(sizer_15, 0, wx.EXPAND, 0)
        sizer_9.Add((20, 15), 0, 0, 0)
        sizer_3.Add(self.label_10, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 25)
        sizer_9.Add(sizer_3, 1, wx.EXPAND, 0)
        sizer_12.Add(self.button_6, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_14.Add(self.text_ctrl_2, 0, wx.EXPAND, 0)
        sizer_12.Add(sizer_14, 1, wx.EXPAND, 0)
        sizer_12.Add(self.button_8, 0, 0, 0)
        sizer_12.Add((20, 20), 0, 0, 0)
        sizer_13.Add(sizer_12, 0, wx.EXPAND, 0)
        sizer_9.Add(sizer_13, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_7.Add(self.button_2, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_7.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_1.Add(sizer_7, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_5.Add(self.button_1, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_5.Add(self.text_ctrl_1, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_5.Add(self.label_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_1.Add(sizer_5, 0, wx.EXPAND, 0)
        sizer_1.Add(self.label_3, 0, wx.LEFT | wx.RIGHT, 40)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_8.Add(self.button_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_20.Add(self.label_7, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_20.Add(self.checkbox_1, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_19.Add(sizer_20, 1, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_18.Add(sizer_19, 1, wx.EXPAND, 0)
        sizer_8.Add(sizer_18, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_8, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_21.Add(self.button_3, 0, wx.LEFT, 20)
        sizer_21.Add(self.label_5, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_6.Add(sizer_21, 0, wx.EXPAND, 0)
        sizer_1.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_17.Add(self.button_10, 0, wx.LEFT, 20)
        sizer_17.Add(self.label_12, 0, wx.LEFT | wx.RIGHT, 20)
        sizer_17.Add(self.button_11, 0, 0, 0)
        sizer_16.Add(sizer_17, 0, wx.EXPAND, 0)
        sizer_16.Add(self.label_8, 0, wx.LEFT, 40)
        sizer_1.Add(sizer_16, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 10), 0, 0, 0)
        sizer_4.Add(self.button_7, 0, wx.LEFT | wx.BOTTOM, 20)
        sizer_4.Add(self.label_9, 0, wx.LEFT | wx.BOTTOM | wx.ALIGN_CENTER_VERTICAL, 20)
        sizer_1.Add(sizer_4, 0, wx.EXPAND, 0)
        sizer_1.Add(self.static_line_2, 0, wx.LEFT | wx.RIGHT | wx.EXPAND, 20)
        sizer_11.Add(self.button_5, 0, wx.RIGHT | wx.TOP | wx.BOTTOM | wx.ALIGN_RIGHT | wx.ALIGN_BOTTOM, 20)
        sizer_10.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_10, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #---------コマンドボタン-----------------------
    def onCaseInitialize(self, event): # wxGlade: MyFrame.<event_handler>
        print "casen内のfaileを初期化します。"
        self.caseInitialize()

    #stl場所参照
    def onSetStlLocation(self, event): # wxGlade: MyFrame.<event_handler>
        self.getStlDir()

    #stl場所を開く
    def onOpenStlFolder(self, event):  # wxGlade: MyFrame.<event_handler>
        self.openStlFolder()

    #stlファイルチェック
    def onStlCheck(self, event): # wxGlade: MyFrame.<event_handler>
        print "stlファイルのsolid名をチェックします。"
        self.stlCheck()


    #特徴線抽出
    def onFeatureEdge(self, event): # wxGlade: MyFrame.<event_handler>
        print "特徴線を抽出します。"
        self.featureEdge()

    #Helyxos起動
    def onRunHelyxos(self, event): # wxGlade: MyFrame.<event_handler>
        self.runHelyxos()

    #paraFoam起動
    def onRunParaFoam(self, event):  # wxGlade: MyFrame.<event_handler>
        print "paraFoamを起動します"
        self.runParaFoam(event)

    #snappyDict編集
    def onEditSnappyDict(self, event):  # wxGlade: MyFrame.<event_handler>
        self.editSnappyDict(event)

    #snappy実行
    def onRunSnappy(self, event):  # wxGlade: MyFrame.<event_handler>
        self.runSnappy(event)

    #メッシュ抽出
    def onTopoSetEditor(self, event): # wxGlade: MyFrame.<event_handler>
        print "topoSetEditorを起動します"
        self.runTopoSetEditor()

    #閉じる
    def onClose(self, event): # wxGlade: MyFrame.<event_handler>
        self.endingProcess()
        self.Close(True)

    #----------sub関数------------

    #
    #  editSnappyDict
    #    snappyHexMeshDict, blockMeshDictを編集する
    def editSnappyDict(self, event):
        editFiles  = caseDir + "/system/snappyHexMeshDict "
        editFiles += caseDir + "/system/blockMeshDict"
        pyTreeFoam.runEditor(editFiles)

    #
    #  runSnappy
    #    blockMesh, snappyHexMeshを実行
    def runSnappy(self, event):
        blockDict = "system/blockMeshDict"
        snappyDict = "system/snappyHexMeshDict"
        if (len(glob.glob(caseDir+"/"+blockDict)) == 0
                or len(glob.glob(caseDir+"/"+snappyDict)) == 0):
            title = u"エラー"
            message = u"「blockMeshDict」または「snappyHexhMeshDict」ファイルがsystemフォルダ内に存在しない為、実行できません。"
            self.errDialog(title, message)
            return

        #meshデータ削除
        delFolder = caseDir + "/constant/polyMesh"
        comm = "rm -r " + delFolder
        os.system(comm)
        #blockMesh, snappyHexkMesh実行        
        comm = "cd " + caseDir + ";"
        comm += "blockMesh -dict " + blockDict + ";"
        comm += "snappyHexMesh -overwrite"
        [stat, cont] = pyTreeFoam.runOFUtilityReturnStat(comm)
        print stat
        if stat == "OK":
            title = u"snappyHexMesh実行"
            message = u"blockMesh, snappyHexMeshを実行しました。"
            self.okDialog(title, message)
        else:
            title = u"エラー"
            message = u"mesh エラーが発生しました。logを確認してください"
            self.errDialog(title, message)

    #
    #  caseInitialize
    #    case内のfolder, fileをコピーし、caseを初期化する
    def caseInitialize(self):
        global caseDir, version
        version = getHelyxosVersion()
        newCaseDir = getNewCaseDir(version)
        checkAndCopyConstant(caseDir, newCaseDir)
        checkAndCopyLog(caseDir, newCaseDir)
        checkAndCopySystem(caseDir, newCaseDir)
        title = u"caseの初期化"
        mess = u"HelyxOS(" + version + u")が必要とするfolder, fileを設定しました。"
        print mess
        self.okDialog(title, mess)

    #  getStlDir
    #    stlDirの取得
    def getStlDir(self):
        global stlDir, caseDir
        rootDir = os.environ["HOME"].encode("utf-8")
        title = u"開く"
        message = u"folderを選択する"
        saveDir = os.getcwd()
        os.chdir(caseDir)
        if stlDir[0] != "/":
            stlDir = os.path.abspath(stlDir).encode("utf-8")
        else:
            stlDir = stlDir.encode("utf-8")
        [stat, ansDir] = getOpenFolderDDialog.Show(title, message, rootDir, caseDir, stlDir)
        if stat == "OK":
            stlDir = ansDir
            self.text_ctrl_2.SetValue(stlDir)
        os.chdir(saveDir)

    #  openStlFolder
    #    stlFolderを開く
    def openStlFolder(self):
        global caseDir
        stlFolder = self.text_ctrl_2.GetValue()
        if stlFolder[0] == "/":
            stlDir = stlFolder
        else:
            stlDir = caseDir + "/" + stlFolder
        if len(glob.glob(stlDir)) == 0:
            mess = u"設定したfolderは存在しません。\nstlファイルの場所を再設定してください。"
            self.errDialog(u"エラー", mess)
            return
        #os.system(("nautilus " + stlDir).encode("utf-8"))
        pyTreeFoam.openFolderNautilus(stlDir)


    #  setDataToTextBox
    #    textBoxへdataをセット
    def setDataToTextBox(self):
        global caseDir, stlDir, surfaceAngle, clearMesh
        [stlDir, surfaceAngle, clearMesh] = getHelyxosData(caseDir)
        self.text_ctrl_2.SetValue(stlDir)
        self.text_ctrl_1.SetValue(surfaceAngle)
        if clearMesh == "no":
            self.checkbox_1.SetValue(False)
        else:
            self.checkbox_1.SetValue(True)

    #  runHelyxos
    #    HelyxOSの起動
    def runHelyxos(self):
        global caseDir, stlDir
        config = pyTreeFoam.readConfigTreeFoam()
        OFversion = config[0]
        bashrcFoam = config[1]
        helyxos = config[8]
        if stlDir[0] != "/":
            stlPath = caseDir + "/" + stlDir
        else:
            stlPath = stlDir
        eMeshPath = stlPath
        if OFversion >= "2.1.0":
            if self.checkbox_1.GetValue() == True:
                #meshデータをクリア
                ans = self.deletePolyMesh()
                if ans == "NO":
                    return
            #HelyxOSを起動
            comm = (". " + bashrcFoam + ";"
                    + helyxos + " " + caseDir + " " + stlPath + " " + eMeshPath + " &")
            os.system(comm)
        else:
            title = u"エラー"
            mess = u"OpenFOAMのバージョンが違っています。\n「Helyxos」は、「OpenFOAM 2.1.x」以上で起動してください。"
            self.errDialog(title, mess)

    #  deletePolyMesh
    #    polyMeshフォルダごとゴミ箱に移動
    def deletePolyMesh(self):
        global caseDir
        ans = "YES"
        delDir = caseDir + "/constant/polyMesh"
        checkDir = delDir + "/*"
        if len(glob.glob(checkDir)) >= 1:
            title = u"polyMeshの削除"
            mess = u"meshデータがあるので、mesh編集できません。\n「./constant/polyMesh」をゴミ箱へ移動しますか？"
            ans = self.yesNoDialog(title, mess)
            if ans == "YES":
                #ゴミ箱へ移動
                obj = gio.File(delDir)
                obj.trash()
        return ans                

    #  featureEdge
    #    特徴線を抽出
    def featureEdge(self):
        global caseDir, stlDir
        saveDir = os.getcwd()
        os.chdir(caseDir)
        bashrc = pyTreeFoam.getBashrcFoam()
        stlDir = self.text_ctrl_2.GetValue()
        deg = self.text_ctrl_1.GetValue()
        #files = glob.glob(stlDir + "/all*.stl")
        files = self.getFeatureFiles(stlDir)
        if len(files) == 0:
            return

        title = u"特徴線（feature edge）の抽出"
        if len(files) == 0:
            mess  = u"特徴線（feature edge）を抽出するファイルが選択されていません。\n"
            mess += u"　stl ファイルを選択してください。"
            self.errDialog(title, mess)
            os.chdir(saveDir)
            return

        
        for name in files:
            stlFile = stlDir + "/" + name
            stlName = stlFile.split("/")[-1]
            eMeshFile = stlName.split(".")[0]
            comm = ". " + bashrc + ";"
            comm+= "surfaceFeatureExtract -includedAngle " + deg + " "
            comm+= stlFile + " " + eMeshFile
            os.system(comm)
            comm = "cp ./constant/triSurface/" + eMeshFile + ".eMesh "
            comm+= stlDir
            print comm
            os.system(comm)
        eMeshFiles = glob.glob("./constant/triSurface/*.eMesh")
        eMeshFilesStl = glob.glob(stlDir + "/*eMesh")
        message = str(len(files)) + u"ヶの stl ファイルから特徴線（feature edge）を抽出しました。"
        self.okDialog(title, message)
        os.chdir(saveDir)

    #  stlCheck
    #    stlファイルのsolid名をチェック
    def stlCheck(self):
        global stlDir, caseDir
        stlDir = self.text_ctrl_2.GetValue()
        wdir = os.getcwd()
        os.chdir(caseDir)
        stlFolder = pyTreeFoam.convAbsDir(stlDir)
        if len(glob.glob(stlFolder+"/*.stl")) == 0:
            title = u"stlファイルのチェック"
            mess = stlFolder + u" 内にstlファイルがありません。"
            self.errDialog(title, mess)
            os.chdir(wdir)
            return

        comm = "cd " + stlFolder + "; remakeStl model"
        print "\n" + comm
        comm += " | tee temp.txt"
        os.system(comm)
        title = u"stlファイルのチェック"
        mess = str(len(glob.glob(stlFolder+"/*.stl"))) + u" ヶのstlファイルをチェック"
        mess += u"修正しました。\n"
        f=codecs.open(stlFolder + "/temp.txt", "r", "utf-8")
        cont=f.readlines(); f.close()
        if len(cont) > 10:
            mess += u"...\n"
            for line in cont[-10:]:
                mess += line
        else:
            for line in cont:
                mess += line
        self.okDialog(title, mess)
        os.system("rm " + stlFolder + "/temp.txt")        
        os.chdir(wdir)

    #  runParaFoam
    #    paraFoamを起動
    def runParaFoam(self, event):
        global caseDir
        config = pyTreeFoam.readConfigTreeFoam()
        paraFoam = config[4]
        comm = "cd " + caseDir + ";" + paraFoam + "&"
        os.system(comm)


    #  runTopoSetEditor
    #    toposetEditorを起動
    def runTopoSetEditor(self):
        global caseDir, stlDir
        stlDir = self.text_ctrl_2.GetValue()
        comm = "cd " + caseDir + ";" 
        comm += "topoSetEditor.py " + caseDir + " " + stlDir + " &"
        pyTreeFoam.runOFUtility(comm)

    #  endingProcess
    #    終了処理
    def endingProcess(self):
        global caseDir, stlDir, surfaceAngle, clearMesh
        stlDir = self.text_ctrl_2.GetValue()
        surfaceAngle = self.text_ctrl_1.GetValue()
        if self.checkbox_1.GetValue() == True:
            clearMesh = "yes"
        else:
            clearMesh = "no"
        setHelyxosData(caseDir, stlDir, surfaceAngle, clearMesh)

    #------------------


    #  getFeatureFiles
    #    特徴線を作成するstlファイルを取得
    def getFeatureFiles(self, currDir):
        title = u"特徴線抽出fileの選択"
        mess = u"特徴線（featureEdge）を抽出します。\n特徴線を抽出するfileを選択してください。"
        fileFilter = u"*.stl"
        [status, selFiles] = getFilesDialog(title, mess, currDir, fileFilter)
        if status == "OK":
            return selFiles
        else:
            return []
        

    def versionError(self):
        title = u"エラー"
        message = u"HelyxOSは、OpenF2.1.0 以上で起動してください。"
        self.errDialog(title, message)

    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_HAND) 
        dlg.ShowModal()
        dlg.Destroy()

    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_OK:
            #dlg.Destroy()
            stat = "OK"
            #return "OK"
        else:
            #dlg.Destroy()
            stat = "CANCEL"
            #return "CANCEL"
        return stat

    def yesNoDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.YES | wx.NO | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        stat = ""
        if ans == wx.ID_YES:
            stat = "YES"
        else:
            stat = "NO"
        return stat

    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                               style = wx.OK | wx.ICON_INFORMATION) 
        dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame



#  getHelyxosVersion
#    HelyxOSのバージョンを取得
def getHelyxosVersion():
    version = getHelyxVersion()
    return version

#  getNewCaseDir
#    newCaseのdirを取得
def getNewCaseDir(version):
    name = os.environ["TreeFoamPath"] + "/data/HelyxOS/newCase-" + version
    nameList = glob.glob(name + "*")
    newCaseDir = nameList[-1]
    return newCaseDir

def checkAndCopyConstant(caseDir, newCaseDir):
    needFolders = []
    needFolders.append("/constant/polyMesh")
    needFolders.append("/constant/triSurface")
    writeFolders = []
    for folder in needFolders:
        if len(glob.glob(caseDir + folder)) == 0:
            writeFolders.append(newCaseDir + folder)
    writeClipBoard(writeFolders)
    pasteFolderClipBoard(caseDir + "/constant")

def checkAndCopyLog(caseDir, newCaseDir):
    needFolder = "/log"
    if len(glob.glob(caseDir + needFolder)) == 0:
        folderDir = caseDir + needFolder
        comm = "mkdir " + folderDir
        print comm
        os.system(comm)

def checkAndCopySystem(caseDir, newCaseDir):
    files = glob.glob(newCaseDir + "/system/*")
    needFiles = []
    for name in files:
        needFile = "/".join(name.split("/")[-2:])
        needFiles.append(needFile)
    writeFiles = []
    for name in needFiles:
        if len(glob.glob(caseDir + "/" + name)) == 0:
            writeFiles.append(newCaseDir + "/" + name)
    writeClipBoard(writeFiles)
    pasteClipBoard(caseDir+"/system")

def writeClipBoard(folders):
    global clipBoard
    f=open(clipBoard, "w")
    f.write("foldersCopy\n")
    for folder in folders:
        f.write(folder + "\n")
    f.close()

def pasteFolderClipBoard(pasteDir):
    global clipBoard
    if len(glob.glob(pasteDir)) == 0:
        #folder作成
        comm = "mkdir " + pasteDir
        os.system(comm)
    f=open(clipBoard); contents=f.readlines(); f.close()
    files = contents[1:]
    for name in files:
        folderName = name[:-1].split("/")[-1]
        folderDir = pasteDir + "/" + folderName
        comm = "mkdir " + folderDir
        print comm
        os.system(comm)

def pasteClipBoard(pasteDir):
    global clipBoard
    if len(glob.glob(pasteDir)) == 0:
        #folder作成
        comm = "mkdir " + pasteDir
        os.system(comm)
    f=open(clipBoard); contents=f.readlines(); f.close()
    files = contents[1:]
    for name in files:
        src = name[:-1]
        dst = pasteDir
        print "copy " + src
        shutil.copy(src, dst)

#
#  getHelyxOS_data
#    HelyxOS_dataを取得
def getHelyxosData(caseDir):
    global helyxDataFile, stlDir, surfaceAngle, clearMesh
    helyxData = helyxDataFile.split("/")[-1]
    fileNameCase = caseDir + "/" + helyxData
    fileNameTr = os.environ["TreeFoamPath"] + "/" + helyxDataFile
    if len(glob.glob(fileNameCase)) == 1:
        fileName = fileNameCase
    elif len(glob.glob(fileNameTr)) == 1:
        fileName = fileNameTr
    else:
        fileName = fileNameTr
        stlDir = "./model"
        surfaceAngle = "150"
        clearMesh = "yes"
        contents = "stlDir   " + stlDir + "\n"
        contents+= "surfaceAngle    " + surfaceAngle + "\n"
        contents+= "clearMesh    " + clearMesh + "\n"
        f=open(fileName, "w")
        f.write(contents)
        f.close()

    f=open(fileName)
    contents = f.readlines()
    f.close()
    for line in contents:
        comm = line.split()
        if len(comm) > 1:
            if comm[0] == "stlDir":
                stlDir = comm[1]
            elif comm[0] == "surfaceAngle":
                surfaceAngle = comm[1]
            elif comm[0] == "clearMesh":
                clearMesh = comm[1]
    return [stlDir, surfaceAngle, clearMesh]


#  setHelyxOS_data
#    HelyxOS_dataをfileに書き込む    
def setHelyxosData(caseDir, stlDir, surfaceAngle, clearMesh):
    helyxData = helyxDataFile.split("/")[-1]
    fileName = caseDir + "/" + helyxData
    contents  = "stlDir " + stlDir + "\n"
    contents += "surfaceAngle " + surfaceAngle + "\n"
    contents += "clearMesh " + clearMesh + "\n"
    f=open(fileName, "w"); f.write(contents); f.close()

    


if __name__ == "__main__":
    caseDir = sys.argv[1]
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
