#!/usr/bin/env python
# -*- coding: utf-8 -*-
# generated by wxGlade 0.6.3 on Thu Mar 11 21:50:08 2010
#
#  selectFieldsForEditDialog.py
#
#     Fieldsの選択
#                   folder1                     folder2
#       入力データ:[[folder1,field1,field2,..], [folder2,field1,field2,..], ...]
#
#       11/04/24    新規作成（selectFieldsDialogを変更して作成）
#       12/03/18    アイコンの読み込み先を変更
#          03/24    gridEditor起動時のfieldをdialogのtextBoxから読み込み
#          07/16    timeFolderの選択を追加
#          10/28    FFlistの受け渡しを廃止
#       13/05/09    grid編集ボタン廃止、listBoxの拡大可能に設定
#          09/17    nununiform形式データは、省略してeditorを起動
#          09/28    gzip, binary形式の編集が可能
#

import wx
import os
import sys
import glob
import string
import pyTreeFoam
import setFoamContents
import getFoamContents
from editBoundaryConditionsDialog import (getSaveDisplayFieldsFileName, getDisplayFields, gridEditor_data)

job = ""
title = ""
img = ""
message = ""
folderFieldList = []
fieldList = []
folderList = []
selectedFields = []
frame_1 = ""
editDir = ""
time = ""
nTreeFoamD = ""


def Show(nTreeFoam1, job1, title1, img1, mess1, editDir1):
    global job, frame_1, title, img, message, fieldList, folderList, selectedFields, folderFieldList, editDir, nTreeFoam, time
    nTreeFoam = nTreeFoam1
    job = job1
    editDir = editDir1
    FFlist = pyTreeFoam.setEditFolders(editDir)
    folderFieldList = FFlist
    folderList = setFolders(FFlist)
    fieldList = setFields(FFlist[0])
    title = title1
    message = mess1
    time = editDir.split("/")[-1]
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()


def setFolders(FFlist):
    i=0; folders = []
    while i < len(FFlist):
        folder = FFlist[i][0]
        if folder == ".":
            folder = "(現在のフォルダ）"
        folders.append(folder)
        i=i+1
    return folders


def setFields(data):
    fields = []
    if len(data) == 1:
        return fields
    i=1
    while i < len(data):
        fields.append(data[i])
        i=i+1
    return fields


#----------------以下の内容を変更-----------------------------
#
#  アイコン変更
#



# begin wxGlade: extracode
# end wxGlade


class MyFrame(wx.Frame):
    global job, frame_1, fieldList, folderList, selectedFields, folderFieldList, message, img, title, editDir, nTreeFoam
    def __init__(self, *args, **kwds):
        savePath = os.getcwd()
        os.chdir(os.getenv("HOME")+"/TreeFoam")
        # begin wxGlade: MyFrame.__init__
        kwds["style"] = wx.DEFAULT_FRAME_STYLE
        wx.Frame.__init__(self, *args, **kwds)
        self.bitmap_1 = wx.StaticBitmap(self, -1, wx.Bitmap("./icons/emblem-documents.png", wx.BITMAP_TYPE_ANY))
        self.label_1 = wx.StaticText(self, -1, u"選択された Boundary Field を「zeroGradient」でクリアします")
        self.label_3_copy = wx.StaticText(self, -1, u"時間フォルダ")
        self.combo_box_1 = wx.ComboBox(self, -1, choices=[], style=wx.CB_DROPDOWN)
        self.bitmap_2 = wx.StaticBitmap(self, -1, wx.Bitmap("./icons/folder8.png", wx.BITMAP_TYPE_ANY))
        self.label_4 = wx.StaticText(self, -1, u"Folderを選択")
        self.list_box_2 = wx.ListBox(self, -1, choices=[u"(現在のフォルダ)"], style=wx.LB_MULTIPLE)
        self.bitmap_3 = wx.StaticBitmap(self, -1, wx.Bitmap("./icons/text8.png", wx.BITMAP_TYPE_ANY))
        self.label_2 = wx.StaticText(self, -1, u"Fieldを選択")
        self.checkbox_1 = wx.CheckBox(self, -1, u"全てのFieldを選択")
        self.list_box_1 = wx.ListBox(self, -1, choices=["Je", "ElPot"], style=wx.LB_MULTIPLE)
        self.button_1 = wx.Button(self, -1, u"キャンセル")
        self.button_2 = wx.Button(self, -1, u"Editorで編集")

        self.__set_properties()
        self.__do_layout()

        self.Bind(wx.EVT_TEXT_ENTER, self.onChangeTimeFolder, self.combo_box_1)
        self.Bind(wx.EVT_COMBOBOX, self.onChangeTimeFolder, self.combo_box_1)
        self.Bind(wx.EVT_LISTBOX, self.showFields, self.list_box_2)
        self.Bind(wx.EVT_CHECKBOX, self.changeListBoxStatus, self.checkbox_1)
        self.Bind(wx.EVT_BUTTON, self.cancel, self.button_1)
        self.Bind(wx.EVT_BUTTON, self.OK, self.button_2)
        # end wxGlade

        self.label_1.SetLabel(message)
        os.chdir(savePath)

    def __set_properties(self):
        global nTreeFoam
        # begin wxGlade: MyFrame.__set_properties
        self.SetTitle(u"Boudary Field のクリア")
        self.list_box_2.SetMinSize((200, 100))
        self.list_box_2.SetSelection(0)
        self.checkbox_1.SetValue(1)
        self.list_box_1.SetMinSize((200, 100))
        self.list_box_1.Enable(False)
        self.list_box_1.SetSelection(0)
        self.button_1.SetFocus()
        # end wxGlade
        self.SetTitle(title + " (" + nTreeFoam + ")")
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(folderList)
        self.list_box_1.Clear()
        self.list_box_1.AppendItems(fieldList)
        self.list_box_2.Select(0)
        #チェックボックス、リストボックス設定
        self.setCheckBox_listBox(editDir, folderList, fieldList)
        #コンボボックスの設定
        self.setComboBox()


    def __do_layout(self):
        # begin wxGlade: MyFrame.__do_layout
        sizer_1 = wx.BoxSizer(wx.VERTICAL)
        sizer_13 = wx.BoxSizer(wx.VERTICAL)
        sizer_14 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_7 = wx.BoxSizer(wx.VERTICAL)
        sizer_8 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_11 = wx.BoxSizer(wx.VERTICAL)
        sizer_12 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_9 = wx.BoxSizer(wx.VERTICAL)
        sizer_10 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_6 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_2 = wx.BoxSizer(wx.HORIZONTAL)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.bitmap_1, 0, 0, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_2.Add(self.label_1, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_2.Add((20, 20), 0, 0, 0)
        sizer_1.Add(sizer_2, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_1.Add(self.label_3_copy, 0, wx.LEFT, 25)
        sizer_6.Add(self.combo_box_1, 0, wx.LEFT, 20)
        sizer_1.Add(sizer_6, 0, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_10.Add((20, 25), 0, 0, 0)
        sizer_10.Add(self.bitmap_2, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_10.Add(self.label_4, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_9.Add(sizer_10, 0, wx.EXPAND, 0)
        sizer_9.Add(self.list_box_2, 1, wx.LEFT | wx.EXPAND, 20)
        sizer_8.Add(sizer_9, 1, wx.EXPAND, 0)
        sizer_8.Add((20, 20), 0, 0, 0)
        sizer_12.Add(self.bitmap_3, 0, wx.ALIGN_CENTER_VERTICAL, 0)
        sizer_12.Add(self.label_2, 0, wx.LEFT | wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_12.Add(self.checkbox_1, 0, wx.LEFT | wx.RIGHT | wx.ALIGN_CENTER_VERTICAL, 3)
        sizer_11.Add(sizer_12, 0, wx.EXPAND, 0)
        sizer_11.Add(self.list_box_1, 1, wx.RIGHT | wx.EXPAND, 20)
        sizer_8.Add(sizer_11, 1, wx.EXPAND, 0)
        sizer_7.Add(sizer_8, 1, wx.EXPAND, 0)
        sizer_1.Add(sizer_7, 1, wx.EXPAND, 0)
        sizer_1.Add((20, 20), 0, 0, 0)
        sizer_14.Add(self.button_1, 0, wx.RIGHT | wx.ALIGN_RIGHT, 20)
        sizer_14.Add(self.button_2, 0, wx.LEFT | wx.RIGHT | wx.BOTTOM, 20)
        sizer_13.Add(sizer_14, 0, wx.ALIGN_RIGHT, 0)
        sizer_1.Add(sizer_13, 0, wx.EXPAND, 0)
        self.SetSizer(sizer_1)
        sizer_1.Fit(self)
        self.Layout()
        # end wxGlade

    #コンボボックスの設定
    def setComboBox(self):
        global time, editDir
        numDir = "/".join(editDir.split("/")[:-1])
        times = pyTreeFoam.getTimeFolders(numDir)
        self.combo_box_1.Clear()
        i=0
        for item in times:
            self.combo_box_1.Append(times[i])
            i += 1
        self.combo_box_1.SetStringSelection(time)

    #チェックボックス、リストボックスの設定
    def setCheckBox_listBox(self, editDir, folderList, fieldList):
        fileName = getSaveDisplayFieldsFileName(editDir)
        if len(glob.glob(fileName)) != 0:
            self.label_2.Enable(True)
            self.checkbox_1.SetValue(0)
            self.list_box_1.Enable(True)
            dispNames = getDisplayFields(fileName)
            i = 0
            for name in fieldList:
                for dispName in dispNames:
                    if name == dispName:
                        self.list_box_1.Select(i)
                        break
                i += 1

    def changeListBoxStatus(self, event): # wxGlade: MyFrame.<event_handler>
        if self.checkbox_1.Value == True:
            self.label_2.Enable(False)
            self.list_box_1.Enable(False)
        else:
            self.label_2.Enable(True)
            self.list_box_1.Enable(True)

    def showFields(self, event): # wxGlade: MyFrame.<event_handler>
        self.setFieldsToListBox()

    #timeFolderセット
    def onChangeTimeFolder(self, event): # wxGlade: MyFrame.<event_handler>
        global time, editDir, folderFieldList
        time = self.combo_box_1.GetValue()
        editDir = "/".join(editDir.split("/")[:-1]) + "/" + time
        folderFieldList = self.setFFlist(editDir)
        self.setFolderList(folderFieldList)
        self.setFieldsToListBox()


    #  setFFlist
    #    set folderFieldList
    def setFFlist(self, timeFolder):
        ans = []
        [folders, fields] = pyTreeFoam.getFoldersFiles(timeFolder)
        folders.sort()
        folderFields = ["."]
        for field in fields:
            folderFields.append(field)
        ans.append(folderFields)
        if len(folders) != 0:
            for folder in folders:
                folderFields = [folder]
                fieldDir = timeFolder + "/" + folder
                [dummy, files] = pyTreeFoam.getFoldersFiles(fieldDir)
                fields = self.checkDispFields(fieldDir, files)
                fields.sort()
                for field in fields:
                    folderFields.append(field)
                ans.append(folderFields)
        return ans


    def checkDispFields(self, fieldDir, fields):
        fileName = getSaveDisplayFieldsFileName(fieldDir)
        if len(glob.glob(fileName)) != 0:
            dispFields = getDisplayFields(fileName)
            for dispField in dispFields:
                flag = 0
                for field in fields:
                    if dispField == field:
                        flag = 1
                        break
                if flag == 0:
                    fields.append(dispField)
        return fields

    #  setFolderList
    #    folder名をlistBoxにセット
    def setFolderList(self, folderFieldsList):
        global folderList
        newFolders = []
        for folderFields in folderFieldsList:
            newFolders.append(folderFields[0])
        newFolders[0] = "(現在のフォルダ)"
        folderList = newFolders
        self.list_box_2.Clear()
        self.list_box_2.AppendItems(newFolders)
        self.list_box_2.SetSelection(0)

    #  setFieldsToListBox
    #    field名をlistboxにセットしeditDirをセット
    def setFieldsToListBox(self):
        global folderFieldList, editDir
        folderNo = self.list_box_2.GetSelections()
        if len(folderNo) > 0:
            fields = folderFieldList[folderNo[0]]
            fieldList = fields[1:]
            self.list_box_1.Clear()
            self.list_box_1.AppendItems(fieldList)
            #checkbox=ON
            self.checkbox_1.SetValue(1)
            self.label_2.Enable(False)
            self.list_box_1.Enable(False)
            if folderNo[0] == 0:
                fieldDir = editDir
            else:
                fieldDir = editDir + "/" + folderList[folderNo[0]]
            self.setCheckBox_listBox(fieldDir, folderList, fieldList)


    def OK(self, event): # wxGlade: MyFrame.<event_handler>
        global selectedFields, folderFieldList
        selectedFields = []
        folderNo = frame_1.list_box_2.GetSelections()
        if (len(folderNo) == 0):
            selectedFields = []
        elif len(folderNo) == 1:
            nn = folderNo[0]
            if frame_1.checkbox_1.Value == True:
                selectedFields.append(folderFieldList[nn])
            else:
                fields = []
                fields.append(folderFieldList[nn][0])
                fieldNo = frame_1.list_box_1.GetSelections()
                for n in fieldNo:
                    fields.append(folderFieldList[nn][n+1])
                selectedFields.append(fields)
        elif (len(folderNo) > 1):
            if job == "editField":
                selectedFields = []
                title = "error"
                msg = "boundary Field の編集では、複数の時間フォルダを選択できません。"
                self.errDialog(title, msg)
            else:
                for n in folderNo:
                    selectedFields.append(folderFieldList[n])
        else:
            selectedFields = []


        # field の編集
        if job == "editField":
            wdir = os.getcwd()
            os.chdir(editDir)
            self.editFields(selectedFields)
            os.chdir(wdir)


    #  editFields
    #    fieldの編集
    def editFields(self, editList):
        if len(editList) != 0:
            i = 0; arg = ""
            while i < len(editList):
                j = 1
                while j < len(editList[i]):
                    arg = arg + editList[i][0] + "/" + editList[i][j] + " "
                    j = j + 1
                i = i + 1
            files = arg.split()
            binary = False
            for fileName in files:
                cont = getFoamContents.readFile2000Bytes(fileName)
                fileFormat = getFoamContents.checkBinary(cont)
                if fileFormat == "binary":
                    binary = True
                    break
            nMaxLines = getMaxLines()
            title = u"fieldの編集"
            if binary == True:
                mess = u"編集するfieldには、binary部が含まれています。\n　binary部（nonuniformを含む行）は、編集できません。"
            else:
                mess = u"nonuniform の行は、「" + str(nMaxLines) + u"」ヶのデータのみ表示します。\n"
                mess += u"    xxxx nonuniform List<xxx>\n"
                mess += u"    xx(xxx xxx xxx...);\n"
                mess += u"nonuniform のデータ数が「" + str(nMaxLines) + u"」以下の場合、編集できます。\n"
                mess += u"データ数が「" + str(nMaxLines) + u"」ヶを越える場合は、nonuniform を含む行のみ編集できません。"
            self.okDialog(title, mess)
            tempFolder = os.environ["TreeFoamPath"] + "/temp"
            comm = "editFoamFile.py -t " + tempFolder + " " + arg + " &"
            os.system(comm)


    def cancel(self, event): # wxGlade: MyFrame.<event_handler>
        global selectedFields
        print "exit from selectFieldsDialog."
        selectedFields = []
        frame_1.Destroy()
        event.Skip()



    def okCancelDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.CANCEL | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        if ans == wx.ID_OK:
            dlg.Destroy()
            return "OK"
        else:
            dlg.Destroy()
            return "CANCEL"

    #警告
    def warnDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.ICON_EXCLAMATION) 
        ans = dlg.ShowModal()
        dlg.Destroy()

    #エラー
    def errDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.ICON_HAND) 
        ans = dlg.ShowModal()
        dlg.Destroy()

    #OK
    def okDialog(self, title, message):
        dlg = wx.MessageDialog(self, message, title,
                             wx.OK | wx.ICON_INFORMATION) 
        ans = dlg.ShowModal()
        dlg.Destroy()

# end of class MyFrame


#
#  getMaxLines
#    nMaxLinesBinToAscii
def getMaxLines():
    setFile = os.environ["TreeFoamPath"] + "/" + gridEditor_data
    f=open(setFile); cont=f.readlines(); f.close()
    for line in cont:
        words = line.split()
        if len(words) >= 2:
            if words[0] == "nMaxLinesBinToAscii":
                nMaxLines = int(words[1])
    return nMaxLines    




if __name__ == "__main__":
    #変数の取得
    nTreeFoam = sys.argv[1]
    job =       sys.argv[2]
    title =     sys.argv[3]
    img =       sys.argv[4]
    message =   sys.argv[5]
    editDir =   sys.argv[6]
    FFlist = pyTreeFoam.setEditFolders(editDir)
    folderFieldList = FFlist
    folderList = setFolders(FFlist)
    fieldList = setFields(FFlist[0])
    time = editDir.split("/")[-1]

    #dialog表示
    app = wx.PySimpleApp(0)
    wx.InitAllImageHandlers()
    frame_1 = MyFrame(None, -1, "")
    app.SetTopWindow(frame_1)
    frame_1.Show()
    app.MainLoop()
